//+------------------------------------------------------------------+
//|                                              AscTrend_NonLag.mq4 |
//|                                        code by Newdigital        |
//|                                        http://www.forex-tsd.com  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|  M30 timeframe                                                   |
//+------------------------------------------------------------------+

#property copyright "newdigital"
#property link      "http://www.forex-tsd.com"

extern int MAGIC = 363200;

extern string PARAMETERS_TRADE = "PARAMETERS TRADE";
extern double Lots = 0.10;
extern int Slippage = 4;
extern double lStopLoss = 60;
extern double sStopLoss = 60;


extern string PARAMETERS_EXPERT = "PARAMETERS EXPERT";
extern color clOpenBuy = Blue;
extern color clCloseBuy = Aqua;
extern color clOpenSell = Red;
extern color clCloseSell = Violet;
extern color clModiBuy = Blue;
extern color clModiSell = Red;
extern string Name_Expert = "AscTrend_NonLag";
extern bool UseSound = False;
extern string NameFileSound = "alert.wav";
extern bool UseHourTrade = False;
extern int FromHourTrade = 8;
extern int ToHourTrade = 19;

extern string PARAMETERS_INDICATOR_ONE  = "RSIFilter";
extern int PeriodRSI=9;

extern string PARAMETERS_INDICATOR_TWO = "NonLagMA";
extern int     Price          = 0;
extern int     Length         = 100;
extern int     Displace       = 0;
extern int     Filter         = 1;

extern string PARAMETERS_INDICATOR_THREE  = "ASCTrend";
extern bool    UseASCtrend    = false;
extern int     RISK           = 3;

int SoundON=0;
int EmailON=0;
int trend,trend1;
double NLMA, NLMA1;
int MAtrend, MAtrend1; 
int asctrend,asctrend1;
int ASCtrend,ASCtrend1;

double diNonLagUp, diNonLagUp1;
double diNonLagDown, diNonLagDown1;



void deinit() {
   Comment("");
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start(){
      
   if (UseHourTrade){
      if (!(Hour()>=FromHourTrade && Hour()<=ToHourTrade)) {
         Comment("Time for trade has not come else!");
         return(0);
   }  
   }
   if(Bars<100){
      Print("bars less than 100");
      return(0);
   }
   if(lStopLoss<10){
      Print("StopLoss less than 10");
      return(0);
   }
   
  
   if(sStopLoss<10){
      Print("StopLoss less than 10");
      return(0);
   }
   

double diRSIFilter= RSIFilter(PeriodRSI,1);
double d22=(0);

diNonLagUp= NonLagMA( Price, Length,Filter,0,1);
diNonLagDown=NonLagMA( Price, Length,Filter,1,1);
double d24=(0);
if (UseASCtrend)
{
ASCtrend = ASCTrend(RISK);
bool ASCtrendBuy  = ASCtrend>0 && ASCtrend1<0;  
bool ASCtrendSell = ASCtrend<0 && ASCtrend1>0;
} 
else {ASCtrendBuy = true; ASCtrendSell = true;}
  
   if(AccountFreeMargin()<(1000*Lots)){
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);
   }
   if (ExistPositions()){
      if(OrderType()==OP_BUY){

         if ((diNonLagDown > 0 && diNonLagDown1 < 0 )){
            CloseBuy();
            //return(0);
         }
      }
      if(OrderType()==OP_SELL){

         if ((diNonLagUp > 0 && diNonLagUp1 < 0)){
            CloseSell();
            //return(0);
         }
      }
   }
        
   if (!ExistPositions()){
             
      if ((diRSIFilter>d22 && diNonLagUp>0 && ASCtrendBuy )){
         //Print(" Up=",diNonLagUp," Up1=",diNonLagUp1);
         OpenBuy();
         return(0);
      }

      if ((diRSIFilter<d22 && diNonLagDown>0 && ASCtrendSell)){
         //Print(" Dn=",diNonLagDown," Dn1=",diNonLagDown1);
         OpenSell();
         return(0);
      }
   }
   ASCtrend1=ASCtrend;
   diNonLagUp1=diNonLagUp;
   diNonLagDown1=diNonLagDown;
   return (0);
}

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
				return(True);
			}
		} 
	} 
	return(false);
}

 

void CloseBuy() { 
   bool fc; 
   fc=OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy); 
   if (fc && UseSound) PlaySound(NameFileSound); 
} 
void CloseSell() { 
   bool fc; 
   fc=OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell); 
   if (fc && UseSound) PlaySound(NameFileSound); 
} 
void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = GetStopLossBuy(); 
   ldTake = 0; 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_BUY,ldLot,Ask,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenBuy); 
   if (UseSound) PlaySound(NameFileSound); 
} 
void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 

   ldLot = GetSizeLot(); 
   ldStop = GetStopLossSell(); 
   ldTake = 0; 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_SELL,ldLot,Bid,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenSell); 
   if (UseSound) PlaySound(NameFileSound); 
} 
string GetCommentForOrder() { 	return(Name_Expert); } 
double GetSizeLot() { 	return(Lots); } 
double GetStopLossBuy() { 	return (Bid-lStopLoss*Point);} 
double GetStopLossSell() { 	return(Ask+sStopLoss*Point); }

double RSIFilter(int Per, int Bar)
{

   double RSI=iRSI(NULL,0,Per,PRICE_CLOSE,Bar);
   	
	trend=trend1;
	  
	if (RSI>70)  trend=1; 
	if (RSI<30)  trend=-1;
	  
	  if (trend>0) 
	  {
	  if (RSI > 40) int Dir=1.0;
	  else Dir=0;
	  }
	  if (trend<0) 
	  {
	  if (RSI < 60) Dir=-1.0;
	  else Dir = 0;
	  }
	trend1 = trend; 
return(Dir);
}

double NonLagMA( int price,int per,double filter,int mode, int Bar)
{
   double Cycle=4;
   double pi = 3.1415926535, Weight=0, Sum=0, t=0, g=0, alfa=0, beta=0, Up=0, Dn=0;    
   double Coeff = 3*pi;
   int Phase = per-1;
   int Len = per*Cycle + Phase;  

   Weight=0; Sum=0; t=0;
       
      for (int i=Bar;i<=Bar+Len-1;i++)
	   { 
      g = 1.0/(Coeff*t+1);   
      if (t <= 0.5 ) g = 1;
      beta = MathCos(pi*t);
      alfa = g * beta;
      Sum += alfa*iMA(NULL,0,1,0,MODE_SMA,Price,i);
      Weight += alfa;
      if ( t < 1 ) t += 1.0/(Phase-1.0); 
      else if ( t < 2*Cycle )  t += (2.0*Cycle-1.0)/(Cycle*per-1.0);
      }
   NLMA1 = NLMA;
   if( Weight > 0 ) NLMA = Sum/Weight;
   //Print("MA=",NLMA," MA1=",NLMA1);
   
   if ( filter>0 )
   if ( MathAbs( NLMA - NLMA1) < filter*Point ) NLMA=NLMA1;
  
      MAtrend=MAtrend1;
      if (NLMA-NLMA1 > filter*Point) MAtrend = 1; 
      if (NLMA1-NLMA > filter*Point) MAtrend =-1; 
         if (MAtrend > 0)
         {  
         Up = NLMA;
         Dn = -1;
         }
         if (MAtrend < 0) 
         {
         Dn = NLMA;
         Up = -1;
         }
      MAtrend1=MAtrend;
if ( mode==0 ) return(Up);
if ( mode==1 ) return(Dn);
}

int ASCTrend( int risk )
{

   double smin, smax, bsmin, bsmax;

   smin=Low[Lowest(NULL,0,MODE_LOW,9,1)]; 
   smax=High[Highest(NULL,0,MODE_HIGH,9,1)];

   bsmax = smax-(smax - smin)*(33.0-risk)/100.0;
   bsmin = smin+(smax - smin)*(33.0-risk)/100.0;

   asctrend = asctrend1;
   
   if(Close[1]>bsmax)  asctrend= 1; 
   if(Close[1]<bsmin)  asctrend=-1;
   
   asctrend1 = asctrend;
  return(asctrend);
}   